package com.unleashedsoftware.sdk.serialisation;

import org.codehaus.jackson.*;
import org.codehaus.jackson.map.*;
import java.io.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class JsonMicrosoftDateDeserialiser extends JsonDeserializer<Date> {
    private final static String microsoftDatePattern = "(.*?)(\\d+)(.*?)";

    public Date deserialize(JsonParser jsonParser, DeserializationContext deserializationContext) throws IOException {
        String parsedDate = parseDate(jsonParser.getText());
        if(parsedDate == null)
            return null;
        Long timestamp = new Long(parsedDate);
        return new Date(timestamp);
    }

    private String parseDate(String text) throws IOException {
        if(text.length() == 0)
            return null;

        Pattern pattern = Pattern.compile(microsoftDatePattern);
        Matcher matcher = pattern.matcher(text);
        if(!matcher.matches())
            return null;

        return matcher.group(2);
    }
}
